#include "Python.h"
#include "splitqname.h"

void SPLITQNAME(PyObject *qualifiedName, PyObject **prefix, PyObject **localName)
{
  int i;
  Py_UNICODE colon = ':';
  int len = PyUnicode_GET_SIZE(qualifiedName);
  const Py_UNICODE *p = PyUnicode_AS_UNICODE(qualifiedName);
  
  for (i = len-1; i > -1; i--) {
    if (p[i] == colon) {
      *prefix = PyUnicode_FromUnicode(p, i);
      /* skip over the colon */
      i++;
      *localName = PyUnicode_FromUnicode((p + i), (len - i));
      return;
    }
  }

  /* No prefix */
  *prefix = Py_None;
  Py_INCREF(Py_None);
  *localName = qualifiedName;
  Py_INCREF(qualifiedName);
  return;
}

